library yomp_yaml;

import 'package:yaml/yaml.dart' as yaml;

part 'encoder.dart';

abstract class Writer {
	void writeLine(String str);
}

class StringWriter extends Writer {
	String _final = "";
	String get Result => this._final; 
	void writeLine(String str) {
		this._final += str + '\n';
	}
}

Object
decode(String str) {
	List ls = yaml.loadYamlStream(str);
	if (ls.length == 1)
		return ls.first;
	return ls;
}

String
encode(Object obj) {
	StringWriter sw = new StringWriter();
	Encoder enc = new Encoder(sw);
	enc.encode(obj);
	return sw.Result;
}